
#ifndef _AI
#define _AI

#include "player.h"
#include "fifoStack.h"
#include "point.h"
#include "order.h"
#include "config.h"

class AI
{
private:
	PlayerArray* pa;
	Player* bot;
	Player* catcher;
	Player* visionArea[MAX_PLAYERS];
	short visionCount;

	enum AIState
	{
		WALKING_AROUND = 0,
		RUNNING,
		HUNTING,
	};
	AIState myState;

	Vector dest;
	bool hasDestination;


	bool iCanSee (Player* other);
	void updateVision ();
	void WalkAroundState (FifoStack &stack, short turn);
	void HuntState (FifoStack &stack, short turn);
	void RunState (FifoStack &stack, short turn);

public:
	AI ();
	void Init (PlayerArray* players, short id);
	void updateCatcher (Player* p);
	void RunAI (FifoStack &stack, short turn);
};

#endif
