
#ifndef _CUSTOMSOCKET
#define _CUSTOMSOCKET

#include "order.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include <netdb.h>

struct Connection
{
	int socket;
	int connectionId;
	bool active;
};

class BaseServer
{
private:
	struct Connection connectionArray[8];

	// listen on sock_fd
	int sockfd;
	 // new connection on new_fd
	int new_fd;
	// my address information
	struct sockaddr_in my_addr;
	// connector's address information
	struct sockaddr_in their_addr;
	socklen_t sin_size;

public:
	// Number of Connections
	int size;
	int lastConnectionId;
public:
	BaseServer();
	bool makeServer(int port);
	bool Accept();
	void Send(void* buffer, int bufferSize, int index);
	void SendToAll(void* buffer, int bufferSize);
	void SendToAllExcept(void* buffer, int bufferSize, int id);
	int Receive(void* buffer, int bufferSize, int index);
	short nextConnection();
	void deactivateConnection(int connectionId);
};

class BaseClient
{
private:
	int mySocket;
public:
// 	int connectionId;

public:
	BaseClient();
	int Socket() { return mySocket; }
	bool makeClient(int port, char* host);
	int Send(void* buffer, int size);
	int Receive(void* buffer, int size);
};

#endif
