
#include "fifoStack.h"

#include <stdlib.h>

StackNode::StackNode(Order* myOrder)
{
	info = myOrder;
	next = NULL;
}

FifoStack::FifoStack()
{
	first = NULL;
	last = NULL;
	forSearch = NULL;
}

void FifoStack::Initialize()
{
	first = NULL;
	last = NULL;
	forSearch = NULL;
}

bool FifoStack::isEmpty()
{
	return (first == NULL);
}

void FifoStack::Push(Order* myOrder)
{
	StackNode* myStackNode = new StackNode(myOrder);

	if (this->isEmpty())
	{
		first = myStackNode;
		last = myStackNode;
		return;
	}

	last->next = myStackNode;
	last = myStackNode;
}

Order* FifoStack::Pop()
{
	if (this->isEmpty())
	{
		return NULL;
	}

	StackNode* value = first;
	Order* order = value->info;

	first = first->next;
	
	if (this->isEmpty())
	{
		last = NULL;
	}

	delete value;
	return order;
}

void FifoStack::startSearch()
{
	forSearch = first;
}

bool FifoStack::finishedSearch()
{
	return (forSearch == NULL);
}

Order* FifoStack::Search()
{

	Order* myOrder = forSearch->info;
	forSearch = forSearch->next;
	return myOrder;
}
