
#ifndef _GUI
#define _GUI

#include "fifoStack.h"
#include "player.h"
#include "point.h"
#include "ai.h"

#include <allegro.h>

class Gui
{
private:
	BITMAP* buffer;
	BITMAP* map;
	bool quitting;
	bool showStats;
	AI* ai;
public:
	short playerId;
	int turn;
	FifoStack orderStack;
	
private:
	void drawPlayer (Player* myPlayer);
	void loadMap ();
	void drawMap ();
	void drawInformation (PlayerArray* pa);
	int xScroll (Player* myPlayer);
	int yScroll (Player* myPlayer);
	void BlitOnScreen (Player* myPlayer);
public:
	Gui();
	~Gui();
	static void InitializeAllegro ();
	void handleEvents ();
	void Draw (PlayerArray* pa);
	void nextTurn ();

	void setAI (PlayerArray* pa);
	void updateCatcher (Player* p);
};

#endif
