
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "menu.h"
#include "engineClient.h"
#include "engineServer.h"

int main(int argc, char* argv[])
{
	Gui::InitializeAllegro();
	Menu startMenu;

	while (true)
	{
		startMenu.Run();
	
		if (startMenu.isServer())
		{
			//! Server
			EngineServer* myEngine;

			if (argc == 1)
				// HUMAN
				myEngine = new EngineServer(DEFAULT_PORT, startMenu.playerName, true);
			else
				// AI
				myEngine = new EngineServer(DEFAULT_PORT, startMenu.playerName, false);

			myEngine->Run();

			delete myEngine;

			return 0;
		}
		else if (startMenu.isClient())
		{
			//! Client
			EngineClient* myEngine;

			if (argc == 1)
				// HUMAN
				myEngine = new EngineClient(true);
			else
				// AI
				myEngine = new EngineClient(false);


			if (myEngine->Connect(DEFAULT_PORT, startMenu.ip))
			{
				myEngine->Run();

				delete myEngine;

				return 0;
			}
			else
			{
				// TODO: Print connection error on menu
			}
		}
		else
		{
			return 0;
		}
	}

	return 0;
}
