
#include "menu.h"
#include "config.h"

#include <allegro.h>
#include <stdio.h>
#include <string.h>

//! Menu Functions

Menu::Menu()
{
	FILE* fp = fopen("../data/config.txt", "r");

	if (fp)
	{
		fscanf(fp, "%s", ip);
		fscanf(fp, "%s", playerName);
	}
	else
	{
		ip[0] = 0;
		playerName[0] = 0;
	}

	selection = 0;
	
	strcpy(options[CREATE_OPTION].name, "Criar");
	options[CREATE_OPTION].position.setVector(40, 40);
	
	strcpy(options[JOIN_OPTION].name, "Conectar");
	options[JOIN_OPTION].position.setVector(40, 60);
	
	strcpy(options[IP_OPTION].name, "Ip: ");
	options[IP_OPTION].position.setVector(80, 80);

	strcpy(options[NAME_OPTION].name, "Nome: ");	
	options[NAME_OPTION].position.setVector(40, 100);

	strcpy(options[EXIT_OPTION].name, "Sair");
	options[EXIT_OPTION].position.setVector(40, 120);
	
	buffer = create_bitmap(XBUFFER, YBUFFER);
}

int Menu::getColor(int i)
{
	if (selection == i)
	{
		return(makecol(220,220,0));
	}
	return(makecol(255,255,255));
}

void Menu::incSelection()
{
	selection++;
	if (selection >= OPTIONS_NUM)
	{
		selection = 0;
	}
}

void Menu::decSelection()
{
	selection--;
	if (selection < 0)
	{
		selection = OPTIONS_NUM;
	}
}

void Menu::DrawOptions()
{
	int x, y;
	for (int i = 0; i < OPTIONS_NUM; i++)
	{
		if (i != IP_OPTION && (i != NAME_OPTION))
		{
			x = options[i].position.getXInt();
			y = options[i].position.getYInt();
			textprintf_ex(buffer, font, x, y, getColor(i), makecol(0,0,0), options[i].name);
		}
	}

	textprintf_ex(buffer, font, options[IP_OPTION].position.getXInt(), options[IP_OPTION].position.getYInt(), getColor(2), makecol(0,0,0), "Ip: %s", ip);
	textprintf_ex(buffer, font, options[NAME_OPTION].position.getXInt(), options[NAME_OPTION].position.getYInt(), getColor(3), makecol(0,0,0), "Nome: %s", playerName);
}

void Menu::Draw()
{
	blit(buffer, screen, 0, 0, 0, 0, XBUFFER, YBUFFER);
	destroy_bitmap(buffer);
	buffer = create_bitmap(XBUFFER, YBUFFER);
}

void Menu::enterText(char* data, int maxSize)
{
	a = readkey();
	// Enter - Down - Up
	while (a != 17165 && (a != 21760) && (a != 21504))
	{
		int size = strlen(data);

		// Backspace
		if (a == 16136)
		{
			if (size > 0)
			{
				data[size-1] = 0;
			}
		}
		else if (size < (maxSize -1))
		{
			data[size] = a;
			data[size+1] = 0;
		}

		DrawOptions();
		Draw();
	
		a = readkey();
	}
}

bool Menu::isClient()
{
	return (choice == JOIN);
}

bool Menu::isServer()
{
	return (choice == CREATE);
}

void Menu::Run()
{
	DrawOptions();
	Draw();
	a = readkey();

	while (true)
	{
		// KEY ENTER
		if (a == 17165)
		{
			if (selection == CREATE_OPTION)
			{
				choice = CREATE;
				break;
			}
			else if (selection == JOIN_OPTION)
			{
				choice = JOIN;
				break;
			}
			else if (selection == EXIT_OPTION)
			{
				choice = EXIT;
				break;
			}
		}
		// KEY DOWN
		else if (a == 21760)
		{
			incSelection();
		}
		// KEY UP
		else if (a == 21504)
		{
			decSelection();
		}
		// KEY ESC
		else if (a == 15131)
		{
			choice = EXIT;
			break;
		}

		DrawOptions();
		Draw();
		
		if (selection == IP_OPTION)
		{
			enterText(ip, MAX_IP);
		}
		else if (selection == NAME_OPTION)
		{
			enterText(playerName, MAX_NAME);
		}
		else
		{
			a = readkey();
		}
	}
}
