
#ifndef _NETGAME
#define _NETGAME

#include "customSocket.h"
#include "fifoStack.h"
#include "player.h"
#include "config.h"

//! Game Information
typedef struct
{
	PlayerArray pa;
	short step;
	short playerId;
	// TODO: short mapId;
} GameInformation;

//! Base NetGame
class NetGame
{
protected:
	FifoStack ordersQueue[CYCLE_SIZE][MAX_PLAYERS];
public:
	short step;

public:
	NetGame();
	void Push(Order* myOrder);
	Order* Pop(short playerId);
	bool hasOrders(short playerId);
	void nextStep();
	void checkStack();
	void initializeMyStack(short myId);
protected:
	void initializePlayerStack(short playerId);
};

//! Client
class NetGameClient : public NetGame
{
public:
	BaseClient myClient;
private:
	short lastReceivedIndex;

public:
	bool joinGame(int port, char* host);
	bool receiveInfo(GameInformation* gameInfo);
	bool SendOrders(FifoStack &orders);
	bool receivePlayer(PlayerArray* pa);
	void ReceiveOrders(PlayerArray* pa);
};

//! Server
class NetGameServer : public NetGame
{
public:
	BaseServer myServer;
public:
	bool Accept(PlayerArray* pa, short turn);
	void SendOrders(FifoStack &myStack);
	void ReceiveAndSendOrders();
};

#endif
