
#ifndef _PLAYER
#define _PLAYER

#include "point.h"
#include "order.h"
#include "config.h"

class Player
{
private:
	enum playerStatus
	{
		CATCHER = 0,
		RUNNER,
		IMMUNE
	};

	playerStatus status;

	short immuneTimer;

public:
	short id;
	bool inGame;
	Vector center; // NOTE: Actually, the center could be an int vector
	Vector speed;
	short beingCatched;
	char name[MAX_NAME];

private:
	void addYSpeed(float value);
	void addXSpeed(float value);
	void Attrition();
	void WindowCollision();
public:
	Player();
	void Create(int playerId);
	void setName(char* playerName);
	int getX();
	int getY();

	void executeOrder(Order* myOrder);
	void Move();

	bool isCatcher();
	bool isRunner();
	bool isImmune();

	void setCatcher();
	void setImmune();
	void setRunner();

	bool checkCollision(Player* other);

	void decImmuneTimer();
};

class PlayerArray
{
private:
	Player array[MAX_PLAYERS];
	bool available[MAX_PLAYERS];
public:
	short totalPlayers; // NOTE: private?
	short size;

public:
	PlayerArray ();
	void deactivatePlayer (int index);
	short emptyPosition ();
	short createNewPlayer ();
	void executeOrder (Order* myOrder);
	Player* getPlayer (int index);
	void setPlayer (Player myPlayer);
	void setNumPlayers( short num);
	Player* getCatcher ();
};

#endif
